# Submitting a Pull Request?

* Namespace your code by folder
* Lowercase namespace (`Lapiz::`)
* Follow the Clang format
    * CLion does this automatically, no need to do anything.
    * Download the Visual Studio Code clang extension.
* When we request changes, you have 1 week to respond. If not we will dismiss the PR, and close it.

The current clang formatting settings are as follow:

```clang
# Style "cscpp"
# global for actions
BasedOnStyle: LLVM
AllowShortBlocksOnASingleLine: true
AllowShortCaseLabelsOnASingleLine: true
AllowShortIfStatementsOnASingleLine: true
Cpp11BracedListStyle: true
IndentWidth: 4
NamespaceIndentation: All
```

# Submitting an issue?

## Feature Request

Go ahead! We'd love to hear what ideas you have for Lapiz. Make sure to make it concice.

## Bug Report

Please make sure to give us the following if applicable:

- Logs
- Game Version
- Lapiz Version
- If your code is open source, a link to it.
- Build Error Messages
- Screenshots of visible bugs.
